#
# Name: Michele Van Dyne
# Description: The client code for the Inflator game
#

import Balloon
import sys
import StdDraw

fname = sys.argv[1]
with open(fname, 'r') as f:
    increaseRadiusBy  = float(f.readline())
    liftPerUnitVolume = float(f.readline())
    requiredLift      = float(f.readline())
    f.readline()
    numBalloons       = int(f.readline())
    f.readline()
    balloons = []

    for i in range(0, numBalloons):
        line = f.readline().split()
        balloons.append(Balloon.Balloon(float(line[0]),       # x
                                        float(line[1]),       # y
                                        float(line[2]),       # max radius
                                        line[3],              # character
                                        int(line[4]),         # red
                                        int(line[5]),         # green
                                        int(line[6])))        # blue                    
    f.close()
StdDraw.setFontSize(16)  

liftPercent = 0.0
for i in range(0, numBalloons):
    balloons[i].draw()
while liftPercent < 100.0:
    totalLift = 0.0
    if StdDraw.hasNextKeyTyped():
        label = StdDraw.nextKeyTyped()
        # Loop over all of them since we may have different balloons with same trigger key
        for i in range(0, numBalloons):
            if balloons[i].matches(label):
                balloons[i].inflate(increaseRadiusBy)
        # Now go through and draw new balloons and get the total lift
        StdDraw.clear()
        for i in range(0, numBalloons):
            balloons[i].draw()
            totalLift += balloons[i].lift(liftPerUnitVolume)
        liftPercent =  totalLift / requiredLift * 100.0
        message = "Lift percent: " + str(int(liftPercent))
        StdDraw.setPenColor(StdDraw.BLACK)
        StdDraw.text(0.1, 0.9, message)
    StdDraw.show(10)

# Display the winning message once the game is over
StdDraw.setFontSize(72)
StdDraw.setPenColor(StdDraw.BLACK)
StdDraw.filledRectangle(0.29, 0.42, 0.43, 0.16)
StdDraw.setPenColor(StdDraw.BLUE)
StdDraw.text(0.5, 0.5, "You win!")
StdDraw.show(2000)
